#include "Client.dm"
#define WALKING 	1
#define FLYING		2
#define PASSWALL	3

turf
  var
    elevation = 1
    flight_dense = 0
  proc/GetBridge(elev)
    for(var/obj/bridge/b in src)
      if(b.elevation == elev)
        return b
  Entered(atom/movable/a)
    if(a.move_standingon)
      var/obj/bridge/b2 = a.move_standingon
      var/obj/bridge/b = GetBridge(b2.elevation)
      if(b)
        a.move_StandOn(b)
      if(elevation==b2.elevation)
        a.move_StepOffLast()

  Enter(atom/a)
    if(istype(a,/mob))
      var/mob/m = a
      if(m.move_IsFlying()&&!flight_dense) return 1
      if(m.move_IsPasswall()) return 1
      if(m.loc)
        if(elevation == m.loc:elevation)
          if(m.move_standingon)
            var/obj/bridge/b2 = m.move_standingon
            if(b2.elevation == elevation)
              return 1
            else
              var/obj/bridge/b = GetBridge(b2.elevation)
              if(b)
                return 1
            return 0
          else
            return ..()
        else
          if(elevation == m.loc:elevation +0.5||elevation == m.loc:elevation -0.5)
            return ..()
          if(m.move_standingon)
            var/obj/bridge/b2 = m.move_standingon
            if(b2.elevation == elevation)
              return 1
            else
              var/obj/bridge/b = GetBridge(b2.elevation)
              if(b)
                return 1
          var/obj/bridge/b = GetBridge(m.loc:elevation)
          if(b)
            m.move_StandOn(b)
            return 1
          return 0
    return ..()
obj/bridge
  var/elevation = 1

atom/movable/Move(nloc)
  if(move_FOBJMove(nloc))
    if(world.realtime >= move_nextmove)
      var/movelag
      if(move_speed==0) movelag = 40
      else
        movelag = 100/move_speed
      move_nextmove = world.realtime + movelag
      ..()
      move_PlaceFOBJs()
    else
      return 0
  else
    move_PlaceFOBJs()
    return 0






obj/var/atom/movable/is_FOBJ = null
atom/movable
  var
    movement[0]
    FOBJ[0]
    FOBJx[0]
    FOBJy[0]

    move_speed = 100
    move_nextmove = 0
    var/obj/bridge/move_standingon
    var/move_backlayer
  proc/move_StandOn(var/obj/bridge/b)
    move_StepOff()
    if(move_backlayer)
      if(layer != move_backlayer)
        spawn() .()
        return
    move_backlayer = layer
    move_standingon = b
    layer = b.layer+1
  proc/move_StepOff()
    if(move_standingon)
      spawn() layer = move_backlayer
      move_standingon = null
  proc/move_StepOffLast()
    if(move_standingon)
      spawn(4) layer = move_backlayer
      move_standingon = null
  Del()
    for(var/o in FOBJ)
      del(FOBJ[o])
    ..()
  proc
    // Adding Objects that follow the atom
    move_PlaceFOBJs()
      for(var/o in FOBJ)
        var/xmod = FOBJx[o]
        var/ymod = FOBJy[o]
        var/turf/t = locate(x+xmod,y+ymod,z)
        var/obj/o2 = FOBJ[o]
        if(o2&&t)
          o2.Move(t)
          o2.dir = dir

    move_GetFOBJ(tag)
      return FOBJ[tag]

    move_AddFOBJ(a,tag,xmod,ymod)
      var/obj/o
      if(isicon(a))
        o = new()
        o.icon = a
      if(istype(a,/image))
        o = new()
        o.icon = a
        o.icon_state = a:icon_state
        o.dir = a:dir
        o.layer = a:layer
      if(isobj(a))
        o = a
      o.is_FOBJ = src
      o.animate_movement = SYNC_STEPS
      FOBJ[tag] = o
      FOBJx[tag] = xmod
      FOBJy[tag] = ymod
      var/turf/t = locate(x+xmod,y+ymod,z)
      if(!o) return
      if(t)
        o.loc = t
        return 1
      else
        o.loc =null
        return 0
    move_RemoveFOBJ(tag)
      var/obj/o = FOBJ[tag]
      FOBJ -= tag
      FOBJx -= tag
      FOBJy -= tag
      return o
    move_FOBJMove(nloc)
      if(!nloc) return 0
      for(var/t in FOBJ)
        var/obj/o = FOBJ[t]
        if(move_FOBJMove_single(o,nloc))
        else
          return 0
      return 1
    move_FOBJMove_single(obj/o,nloc)
      if(!nloc) return 0
      for(var/t2 in FOBJ)
        if(o == FOBJ[t2])
          var/xmod = FOBJx[t2]
          var/ymod = FOBJy[t2]
          var/turf/t = locate(nloc:x+xmod,nloc:y+ymod,nloc:z)
          if(!o) return 0
          if(o.CanEnter(t,nloc)) return 1
          else
            return 0
    //Movement Procs
    move_IsFlying()
      if(movement["Move Type"]==FLYING) return 1
    move_IsWalking()
      if(movement["Move Type"]==WALKING) return 1
    move_IsPasswall()
      if(movement["Move Type"]==PASSWALL) return 1
    move_MoveType()
      return movement["Move Type"]
    move_LockedCur()
      return movement["Lock Cursor"]
    move_LockedPos()
      return movement["Lock Position"]
    move_LockedDown()
      return movement["Lock Down"]
    move_SetMoveType(t)
      switch(t)
        if(WALKING) movement["Move Type"] = t
        if(FLYING) movement["Move Type"] = t
        if(PASSWALL) movement["Move Type"] = t
        else
          CRASH("Invalid move type")

    move_LockDown()
      movement["Lock Down"] = 1
      movement["Lock Position"] = 1
      movement["Lock Cursor"] = 1
    move_UlockDown()
      movement["Lock Down"] = 0
      movement["Lock Position"] = 0
      movement["Lock Cursor"] = 0

    move_LockPos()
      movement["Lock Position"] = 1
    move_UlockPos()
      movement["Lock Position"] = 0

    move_LockCur()
      movement["Lock Cursor"] = 1
    move_UlockCur()
      movement["Lock Cursor"] = 0

    move_Stun(delay = 10)
      move_LockDown()
      spawn(delay)
        if(src) move_UlockDown()

  Move()
    if(move_LockedPos()) return 0
    . = ..()

atom/movable/proc/CanEnter(turf/t,nloc)
  if(!t) return 0
  if(t.density==1) Enter(t)
  for(var/atom/a in t)
    if(a.density==1)
      if(istype(src,/obj))
        if(istype(a,/obj))
          if(src:is_FOBJ==a:is_FOBJ)
            if(src:is_FOBJ.move_FOBJMove_single(a,nloc))
              continue
            else
              if(src:is_FOBJ) src:is_FOBJ.Bump(a)
              return Enter(t)
          else
            if(src:is_FOBJ) src:is_FOBJ.Bump(a)
            return Enter(t)
        else
          if(istype(a,/atom/movable))
            if(src:is_FOBJ==a) continue
            else
              if(src:is_FOBJ) src:is_FOBJ.Bump(a)
              return Enter(t)
          else
            if(src:is_FOBJ) src:is_FOBJ.Bump(a)
            return Enter(t)
      else
        if(src:is_FOBJ) src:is_FOBJ.Bump(a)
        return Enter(t)
  return 1
